<template>
  <main>
    <v-container>
      <v-layout row>
        <v-flex sm12>
          <v-card>
            <v-card-title primary-title>
              <div>
                <div class="headline">User Management</div>
                <div class="grey--text">Lorem ipsum dolor sit amet.</div>
              </div>
              <v-spacer></v-spacer>
              <v-text-field append-icon="search" label="Search" single-line hide-details v-model="search"></v-text-field>
            </v-card-title>
            <!-- Card Content -->
            <v-data-table :headers="headers" :items="items" :search="search" :loading="loading" :rows-per-page-items="[50, 100, 500]">
              <template slot="items" scope="props">
                <tr @click="user(props.item.id)">
                  <td>{{props.item.full_name}}</td>
                  <td>{{props.item.role}}</td>
                  <td>{{props.item.mobile}}</td>
                </tr>
              </template>
            </v-data-table>
          </v-card>
        </v-flex>
      </v-layout>
    </v-container>
  </main>
</template>

<script>
  import AppShell from '@/components/app-shell'
  export default {
    name: 'users',
    components: {AppShell},
    data () {
      return {
        loading: true,
        search: null,
        headers: [
          { text: 'Full Name', value: 'fullName', align: 'left' },
          { text: 'Role', value: 'role', align: 'left' },
          { text: 'Contact', value: 'contact', align: 'left' }
        ],
        items: [],
        db: this.$database.ref('users')
      }
    },
    methods: {
      user (id) { this.$router.push({path: `user/${id}`}) },
      loadUsers (ref) {
        ref.once('value').then(snapshot => {
          let user = snapshot.val()

          if (user) {
            Object.keys(user).forEach(uid => {
              user[uid].id = uid
              this.items.push(user[uid])
            })
          }

          this.loading = false
        })
      }
    },
    created () {
      /*
       * You can extend this with queries
       * https://firebase.google.com/docs/database/web/lists-of-data#sorting_and_filtering_data
       * Example: this.db.orderByChild('propName')
       */
      let ref = this.db
      this.loadUsers(ref)
    }
  }
</script>

<style scoped>
  td:hover { cursor: pointer; }
</style>
